/* David Leonard, 2002. Public domain. */
/* $Id: mine.h,v 1.3 2002/02/16 13:04:16 d Exp $ */

struct mine;

struct mine *mine_new(int rows, int cols, int mines);
void	mine_free(struct mine *m);
/* return -1 on bomb, or # of bombs surrounding; sets test flag */
int	mine_test(struct mine *m, int row, int col);
int	mine_status(struct mine *m, int row, int col);
#define STATUS_UNTESTED		1
#define STATUS_TESTED		2
#define STATUS_MARKED_FLAG	3
#define STATUS_MARKED_UNKNOWN	4
void	mine_mark(struct mine *m, int row, int col, int type);
#define	MARK_NONE	1
#define	MARK_FLAG	2
#define	MARK_UNKNOWN	3
int	mine_remaining(struct mine *m);
void	mine_size(struct mine *m, int *rows, int *cols, int *mines);
/* return 1 on win, -1 on lose */
int	mine_won(struct mine *m);

/* relative coordinates of the 8 surrounding cells */
struct delta {
	int dx, dy;
};
extern struct delta delta[8];

